/*!
 * Copyright (c) <2018> <Andreas Niskanen, University of Helsinki>
 * 
 * 
 * 
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 * 
 * 
 * 
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * 
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

#ifndef INSTANCE_H
#define INSTANCE_H

#include "Example.h"

#include <vector>
#include <map>

class Instance {
public:

int count = 0;

std::vector<int> arguments;
std::vector<std::pair<int,int>> attacks;

std::vector<Example> examples;

std::map<std::string,int> arg_to_index;
std::map<int,std::string> index_to_arg;

std::map<int,int> example_id_to_index;
std::map<int,int> index_to_example_id;

std::map<std::pair<int,int>,int> attack_var;
std::map<int,std::pair<int,int>> var_attack;

std::map<int,int> extension_var;
std::map<int,int> var_extension;

std::map<std::pair<int,std::pair<int,int>>,int> not_defended_var;
std::map<std::pair<int,int>,int> not_attacked_var;
std::map<std::pair<int,int>,int> exists_not_defended_var;

std::map<std::pair<int,int>,int> arg_var;
std::map<std::pair<int,std::pair<int,int>>,int> attacks_var;
std::map<std::pair<int,std::pair<int,int>>,int> attacked_var;
std::map<int,int> exists_superset_var;
std::map<int,int> var_exists_superset;

void add_argument(std::string arg);

void add_example(Example ex);

void initialize(bool adm_in_abstraction);

void print();

};

#endif
