#include "MiniSATSolver.h"

#include <iostream>

using namespace std;
using namespace Minisat;

MiniSATSolver::MiniSATSolver()
{
    solver = new Solver();
}

void MiniSATSolver::add_clause(vector<int> & clause)
{
	vec<Lit> lits;
    for (int i = 0; i < clause.size(); i++) {
        int var = abs(clause[i])-1;
        while (var >= solver->nVars()) {
            solver->newVar();
        }
        lits.push((clause[i] > 0) ? mkLit(var) : ~mkLit(var));
    }
    solver->addClause(lits);
    clauses.push_back(clause);
}

bool MiniSATSolver::solve()
{
	bool sat = solver->solve();
    for (int i = 0; i < solver->model.size(); i++) {
        assignment[i] = (solver->model[i] == l_True) ? 1 : 0;
    }
    return sat;
}